//
//  TVSDocument.m
//  TableViewSpliter
//
//  Created by narita on 2016/07/28.
//  Copyright © 2016年 narita. All rights reserved.
//

#import "TVSDocument.h"
#import "TVSWindowController.h"

@interface TVSDocument ()

@end

@implementation TVSDocument

#pragma mark -
#pragma mark class methods

+ (BOOL)autosavesInPlace
{
    return YES;
}

#pragma mark -
#pragma mark init methods

- (instancetype)init
{
    self = [super init];
    
    if (self)
    {
        self.model = [NSMutableArray array];
        
        for(NSUInteger i = 0; i < 100; i++)
        {
            NSMutableDictionary* theRec = [@{
                                             @"number" : @(i),
                                             @"label" : @"dummy text"
                                             } mutableCopy];
            [self.model addObject:theRec];
        }        
    }
    
    return self;
}

#pragma mark -
#pragma mark dealloc

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark awakeFromNib-like methods

#pragma mark -
#pragma mark restorableState methods

// この記述を行って、multi window documentでstateが復元できる
- (void)restoreDocumentWindowWithIdentifier:(NSString *)identifier
                                      state:(NSCoder *)state
                          completionHandler:(void (^)(NSWindow *, NSError *))completionHandler
{
    TVSWindowController* theWindowController;
    
    theWindowController = (TVSWindowController*)[self makeWindowController];
    
    // restore state のコードが走り出す前に、View構造を構築する必要がある。
    // そのため、ここで追加のView構造を構築する機会をwindowに与える。
    [theWindowController prebuildForRestorableStateWithWindowCoder:state];
    
    completionHandler([theWindowController window], nil);
}

#pragma mark -
#pragma mark action methods

- (IBAction)makeNewDocumentWindow:(id)sender
{
    NSWindowController* theWindowController;
    
    theWindowController = [self makeWindowController];

    [theWindowController showWindow:self];
}

#pragma mark -
#pragma mark delegate/datasource methods

#pragma mark -
#pragma mark WindowController methods

- (NSWindowController*) makeWindowController
{
    NSStoryboard*       theStoryboard;
    NSWindowController* theWindowController;
    
    theStoryboard       = [NSStoryboard storyboardWithName:@"Document"
                                                    bundle:nil];
    
    theWindowController = [theStoryboard instantiateInitialController];
    
    [self addWindowController:theWindowController];
    
    return theWindowController;
}

- (void)makeWindowControllers
{
    [self makeWindowController];
}

// ---------------------------------------------------------------------------
//	addWindowController
// ---------------------------------------------------------------------------
//	ウインドウが追加された場合のタイトルの書き換え
//

- (void)addWindowController: (NSWindowController *)windowController
{
    [super addWindowController:windowController];
    
    [[self windowControllers] makeObjectsPerformSelector:@selector(synchronizeWindowTitleWithDocumentName)];
}

// ---------------------------------------------------------------------------
//	removeWindowController
// ---------------------------------------------------------------------------
//	ウインドウが削除された場合のタイトルの書き換え
//

- (void)removeWindowController: (NSWindowController *)windowController
{
    [super removeWindowController:windowController];
    
    [[self windowControllers] makeObjectsPerformSelector:@selector(synchronizeWindowTitleWithDocumentName)];
}

#pragma mark -
#pragma mark accessor methods (in pairs)


#pragma mark -
#pragma mark File Handling methods

- (NSData *)dataOfType:(NSString *)typeName error:(NSError **)outError
{
    // Insert code here to write your document to data of the specified type. If outError != NULL, ensure that you create and set an appropriate error when returning nil.
    // You can also choose to override -fileWrapperOfType:error:, -writeToURL:ofType:error:, or -writeToURL:ofType:forSaveOperation:originalContentsURL:error: instead.
    [NSException raise:@"UnimplementedMethod" format:@"%@ is unimplemented", NSStringFromSelector(_cmd)];
    return nil;
}

- (BOOL)readFromData:(NSData *)data ofType:(NSString *)typeName error:(NSError **)outError
{
    // Insert code here to read your document from the given data of the specified type. If outError != NULL, ensure that you create and set an appropriate error when returning NO.
    // You can also choose to override -readFromFileWrapper:ofType:error: or -readFromURL:ofType:error: instead.
    // If you override either of these, you should also override -isEntireFileLoaded to return NO if the contents are lazily loaded.
    [NSException raise:@"UnimplementedMethod" format:@"%@ is unimplemented", NSStringFromSelector(_cmd)];
    return YES;
}

#pragma mark -
#pragma mark Utility methods

@end
